from enum import Enum

class Timeout(Enum):
    BACKEND_SSH_TCP = 15
    BACKEND_SSH_BANNER = 15
    BACKEND_SSH_AUTH = 15
    BACKEND_MONGO = 15000
    BACKEND_MYSQL = 15
    BACKEND_MARIADB = 15
    BACKEND_POSTG = 15
    BACKEND_ELASTIC = 15
    BACKEND_REDIS = 15
    BACKEND_MSSQL = 15
    BACKEND_ORACLE = 15.0
    SERVICE_SSH_TCP = 200
    SERVICE_SSH_BANNER = 200
    SERVICE_SSH_AUTH = 200
    SERVICE_MONGO = 30000
    SERVICE_MARIADB = 30
    SERVICE_MYSQL = 30
    SERVICE_POSTG = 30
    SERVICE_ELASTIC = 120
    SERVICE_REDIS = 30
    SERVICE_MSSQL = 30
    SERVICE_ORACLE = 30.0

class RSAKeySize(Enum):
    RSA_1024 = 1024
    RSA_2048 = 2048
    RSA_3072 = 3072

class AESMode(Enum):
    AES_128 = 'aes128'
    AES_192 = 'aes192'
    AES_256 = 'aes256'


class OperatingSystem(Enum):
    LINUX = "LINUX"
    WINDOWS = "WINDOWS"
    CENTOS = "centos"
    UBUNTU = "ubuntu"
    DEBIAN = 'debian'
    REDHAT = 'rhel'
    FEDORA = 'fedora'
    ROCKY = 'rocky'
    INVALID = 'error'
    UNKNOWN = 'unknown'

class SupportedOS(Enum):
    CENTOS = [7, 8, 9]
    UBUNTU = [18, 20, 22]

class DBType(Enum):
    MARIADB = "MARIADB"
    MONGO = "MONGO" 
    POSTGRES = "POSTGRES"
    MYSQL = "MYSQL"
    MSSQL = "MSSQL"
    ELASTIC = "ELASTIC"
    REDIS = "REDIS"
    ORACLE_CDB = "ORACLE_CDB"
    ORACLE_PDB = "ORACLE_PDB"
    HAPROXY = "HAPROXY"

class ClusterRoles(Enum):
    PRIMARY = "PRIMARY"
    STANDBY = "STANDBY"
    ARBITER = "ARBITER"
    BALANCER = "BALANCER"
    PDB = "PDB"
    CDB = "CDB"
    SENTINEL = "SENTINEL"

class RestoreOptions(Enum):
    THIS = "this"
    LATEST = "latest"
    CUSTOM = "custom"

class PythonOS(Enum):
    WINDOWS = 'nt'
    LINUX = 'posix'
    JAVA = 'java'

class Status(Enum):
    OK = ""
    DROPPING = "being dropped"
    CREATING = "being created"
    REGISTERING = "being registered"
    BACKUP = "being backed up"
    STEPDOWN = "stepping down"
    RESTORING = "being restored"
    PROMOTING = "being promoted to primary"
    DEMOTING = "demoting to standby of {}"
    COPYING = "being copied" #source copy status
    REPLICATING = "being replicated" #target copy status
    STARTING = "starting"
    STOPPING = "stopping"
    RESTARTING = "restarting"
    PENDING = "pending"
    DETACHED = "removed from container"
    OFFLINE = "no connection"
    DOWN = "down"
    FAILED = "failed"
    DROPPED = "dropped"
    DELETED = "deleted"
    TASK_RUNNING = "running"
    TASK_PENDING = "ready"
    TASK_ON_DEMAND = "done"

#name - color
class Severity(Enum):
    INFO = "blue"
    NOT_OK = "red"
    WARNING = "yellow"
    OK = "green"

class Inventory(Enum): # backup inventory types
    BACKUP = 'BACKUP'
    EXPORT = 'EXPORT'
    FLASHBACK = 'FLASHBACK'

class Repository(Enum):
    LOCAL = 'local'
    NETWORK = 'network'

class Packages(Enum):
    REPMGR = 'repmgr'
    HAPROXY = 'haproxy'
    PYTHON3 = 'python3'
    COMMON = 'common'
    BASE = 'base'
    CHERRYPY = 'cherrypy'

class Schedule(Enum):
    NOW = 'NOW'
    SCHEDULED = 'SCHED'
    MINUTE = '1_minute'
    HOUR = '1_hour'
    DAY = '1_day'
    SECONDS_15 = '15_seconds'
    MINUTES_5 = '5_minutes'
    MINUTES_10 = '10_minutes'
    MINUTES_15 = '15_minutes'
    HOURS_6 = '6_hours'
    
class LicenseType(Enum): 
    ORACLE = [DBType.ORACLE_CDB.value, DBType.ORACLE_PDB.value]
    MARIADB = [DBType.MARIADB.value]
    MYSQL = [DBType.MYSQL.value]
    MONGO = [DBType.MONGO.value]
    MSSQL = [DBType.MSSQL.value]
    ELASTIC = [DBType.ELASTIC.value]
    POSTGRES = [DBType.POSTGRES.value]
    REDIS = [DBType.REDIS.value]

class MonitorCommand(Enum):
    SSH = 'ssh'
    SQL = 'sql'
    PYTHON = 'python'
    PYTHON3 = 'python3'
    